---
env:
  - MANGOHUD=1
  - MANGOHUD_CONFIG=read_cfg,cpu_mhz,cpu_temp,cpu_power,gpu_temp,gpu_power,gpu_core_clock,fan,battery,round_corners=5.0,font_scale=0.7,alpha=0.6,background_alpha=0.5,gpu_load_change,cpu_load_change,gpu_load_value=50+85,cpu_load_value=65+85,offset_x=-10,offset_y=-10,position=bottom-left
  # - CARGO_REGISTRIES_CRATES_IO_PROTOCOL=sparse
tasks:
  shell_exec:
    clean:
      commands:
        - ezd run rust -- "cargo clean"
    fix:rustfmt:
      commands:
        - cargo +nightly fmt
    fix:clippy:
      commands:
        - ezd run rust -- "cargo clippy --fix --all-features --allow-dirty --allow-staged -- -D warnings"
    fix:
      commands:
        - ezd run fix:rustfmt
        - ezd run fix:clippy
    test:tests:
      commands:
        - ezd run rust -- "cargo-zigbuild test --target=x86_64-unknown-linux-gnu.2.17"
    test:rustfmt:
      commands:
        - ezd run rust -- "cargo +nightly fmt -- --check"
    test:clippy:
      commands:
        - ezd run rust -- "cargo clippy --all-features -- -D warnings"
    test:
      commands:
        - ezd run test:rustfmt
        - ezd run test:clippy
        - ezd run test:tests
    build:debug:
      commands:
        - ezd run rust -- "cargo zigbuild --target=x86_64-unknown-linux-gnu.2.17"
    run:debug:
      commands:
        - ezd run build:debug
        - target/x86_64-unknown-linux-gnu/debug/triton-gui
    build:release:
      commands:
        - ezd run rust -- "cargo +nightly zigbuild -Z build-std=std,panic_abort -Z build-std-features=panic_immediate_abort --release --target=x86_64-unknown-linux-gnu.2.17"
    run:release:
      commands:
        - ezd run build:release
        - target/x86_64-unknown-linux-gnu/release/triton-gui
    build:release-fast:
      commands:
        - ezd run rust -- "cargo +nightly zigbuild -Z build-std=std,panic_abort -Z build-std-features=panic_immediate_abort --profile="release-fast" --target=x86_64-unknown-linux-gnu.2.17"
    run:release-fast:
      commands:
        - ezd run build:release-fast
        - target/x86_64-unknown-linux-gnu/release-fast/triton-gui
    build:x86_64-pc-windows-gnu:release:
      commands:
        - ezd run rust:x86_64-pc-windows-gnu -- cargo +nightly build -Z "build-std=std,panic_abort" -Z "build-std-features=panic_immediate_abort" --profile="release" --target="x86_64-pc-windows-gnu"
    build:x86_64-pc-windows-gnu:release-fast:
      commands:
        - ezd run rust:x86_64-pc-windows-gnu -- cargo +nightly build -Z "build-std=std,panic_abort" -Z "build-std-features=panic_immediate_abort" --profile="release-fast" --target="x86_64-pc-windows-gnu"
    build:x86_64-pc-windows-gnu:debug:
      commands:
        - ezd run rust:x86_64-pc-windows-gnu -- cargo build --target="x86_64-pc-windows-gnu"
    run:wine:debug:
      commands:
        - ezd run build:x86_64-pc-windows-gnu:debug
        - wine64 target/x86_64-pc-windows-gnu/debug/triton-gui.exe
    run:wine:release:
      commands:
        - ezd run build:x86_64-pc-windows-gnu:release
        - wine64 target/x86_64-pc-windows-gnu/release/triton-gui.exe
    run:wine:release-fast:
      commands:
        - ezd run build:x86_64-pc-windows-gnu:release-fast
        - wine64 target/x86_64-pc-windows-gnu/release/triton-gui.exe
  docker_seq:
    rust:
      config:
        image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-unknown-linux-gnu
        volumes:
          - .:/app
          - cache_triton-gui:/usr/local/cargo/registry
        workdir: /app
        sequence:
          - user: 0:0
            commands:
              - useradd --create-home --uid "__EZD_HOST_UID__" "__EZD_HOST_USERNAME__"
              - chown -R "__EZD_HOST_UID__:__EZD_HOST_GID__" "/usr/local/cargo/registry"
          - local_user: true
            commands: [eval "set -eux && $EZD_FORWARDED_ARGS"]
    rust:x86_64-pc-windows-gnu:
      config:
        image: registry.gitlab.com/sbenv/veroxis/images/sdks/rust:1.77.2-x86_64-pc-windows-gnu
        volumes:
          - .:/app
          - cache_triton-gui:/usr/local/cargo/registry
        workdir: /app
        sequence:
          - user: 0:0
            commands:
              - useradd --create-home --uid "__EZD_HOST_UID__" "__EZD_HOST_USERNAME__"
              - chown -R "__EZD_HOST_UID__:__EZD_HOST_GID__" "/usr/local/cargo/registry"
          - local_user: true
            commands: [eval "set -eux && $EZD_FORWARDED_ARGS"]

volumes:
  cache_triton-gui:
